#!/usr/bin/env python

"""Generator of graphs of snapshots.

Usage:
  recreate_graph.py (-f | --file) <graphfile> (-d | --distance_threshold) <dist> (-o | --output) <outputfile>

Options:
  -h --help                     Show this screen.
  -f --file                     File containing complete graph of snapshots.
  -d --distance_threshold       Distance threshold for creating the edges. Snapshots this close or closer will be connected in the output graph.
  -o --output                   File containing the graph of snapshots where connected vertices are closer than the distance threshold.

"""

from docopt import docopt
import math

if __name__ == '__main__':
    arguments = docopt(__doc__)
    graphfile = arguments['<graphfile>']
    outputfile = arguments['<outputfile>']
    threshold = float(arguments['<dist>'])

    gfile = file(graphfile)
    ofile = file(outputfile, "w")

    line = gfile.readline()
    ## iterate through lines
    for line in gfile.readlines():
        if "->" not in line: #vertices and other info goes directly to output
            ofile.write(line)
        else: #edges are checked for distance in
            if "color" in line:
                ofile.write(line)
            else:
                words = line.split()
                distWord = words[5]
                distWord = distWord.replace(",","")
                distWord = distWord.replace("\"","")
                distance = float(distWord)
                if distance < threshold:
                    ofile.write(line)

    gfile.close()
    ofile.close()

